Subject: Re: linux-next: manual merge of the char-misc tree with Linus' tree

From: Greg KH <[email-masked]>
Date: Sat, 28 Aug 2021 09:50:09 +0200

On Sat, Aug 28, 2021 at 10:27:27AM +0300, Kalle Valo wrote:
> Greg KH <[email-masked]> writes:
> 
> > On Fri, Aug 27, 2021 at 11:28:52PM +0530, Manivannan Sadhasivam wrote:
> >> Hi Greg,
> >> 
> >> On Fri, Aug 27, 2021 at 03:12:02PM +0200, Greg KH wrote:
> >> > On Fri, Aug 27, 2021 at 04:49:04PM +1000, Stephen Rothwell wrote:
> >> > > Hi all,
> >> > > 
> >> > > Today's linux-next merge of the char-misc tree got conflicts in:
> >> > > 
> >> > >   drivers/bus/mhi/core/main.c
> >> > >   net/qrtr/mhi.c
> >> > > 
> >> > > between commit:
> >> > > 
> >> > >   9ebc2758d0bb ("Revert "net: really fix the build..."")
> >> > > 
> >> > > from the origin tree and commit:
> >> > > 
> >> > >   0092a1e3f763 ("bus: mhi: Add inbound buffers allocation flag")
> >> > > 
> >> > > from the char-misc tree.
> >> > > 
> >> > > I fixed it up (the commit in Linus' tree is basically a revert of the
> >> > > char-misc tree, so I effectively reverted the latter) and can carry the
> >> > > fix as necessary. This is now fixed as far as linux-next is concerned,
> >> > > but any non trivial conflicts should be mentioned to your upstream
> >> > > maintainer when your tree is submitted for merging.  You may also want
> >> > > to consider cooperating with the maintainer of the conflicting tree to
> >> > > minimise any particularly complex conflicts.
> >> > 
> >> > Hm, what should I do in my tree here?
> >> > 
> >> > Kalle, what commit should I make in the char-misc tree now to handle
> >> > this issue, and make the merge with Linus's tree "simple"?  Or any other
> >> > ideas?
> >> > 
> >> 
> >> For making the merge simpler, I'd suggest we revert below commit in char-misc:
> >> 
> >> 0092a1e3f763 ("bus: mhi: Add inbound buffers allocation flag")
> >
> > Reverting that works for me, I've done that in my tree and that allows
> > it to be merged cleanly with Linus's tree.
> 
> Unfortunately this now breaks the build in char-misc-next (commit
> 0dc3ad3f859d):
> 
> net/qrtr/mhi.c: In function 'qcom_mhi_qrtr_probe':
> net/qrtr/mhi.c:105:48: error: 'MHI_CH_INBOUND_ALLOC_BUFS' undeclared (first use in this function)
>   105 |         rc = mhi_prepare_for_transfer(mhi_dev, MHI_CH_INBOUND_ALLOC_BUFS);
>       |                                                ^~~~~~~~~~~~~~~~~~~~~~~~~
> net/qrtr/mhi.c:105:48: note: each undeclared identifier is reported only once for each function it appears in
> net/qrtr/mhi.c:105:14: error: too many arguments to function 'mhi_prepare_for_transfer'
>   105 |         rc = mhi_prepare_for_transfer(mhi_dev, MHI_CH_INBOUND_ALLOC_BUFS);
>       |              ^~~~~~~~~~~~~~~~~~~~~~~~
> In file included from net/qrtr/mhi.c:6:
> ./include/linux/mhi.h:725:5: note: declared here
>   725 | int mhi_prepare_for_transfer(struct mhi_device *mhi_dev);
>       |     ^~~~~~~~~~~~~~~~~~~~~~~~
> 
> To see this error make sure CONFIG_QRTR and CONFIG_QRTR_MHI are enabled.

Ugh.  Ok, I think I need to now just revert all of the mhi changes in my
tree to get to a "clean state".  Then you all can work this out after
5.15-rc1 is released.

thanks,

greg k-h